<?php if(!defined('IN_GS')){ die('you cannot load this page directly.'); }
/****************************************************
*
* @File:      functions.php
* @Package:   GetSimple
* @Action:    Bootstrap3 for GetSimple CMS
*
*****************************************************/

/**
 * Bootstrap3 Settings
 *
 * This defines variables based on the theme plugin's settings
 *
 * @return bool
 */
function Bootstrap3_Settings() {
    $file = GSDATAOTHERPATH . 'Bootstrap3Settings.xml';
    if (file_exists($file)) {
        return getXML($file);
    } else {
        $XML = <<<XML
<?xml version='1.0'?>
<document>
  <ContactEmail></ContactEmail>
  <DisplayOtherThemes>false</DisplayOtherThemes>
  <InvertNavigationBar>false</InvertNavigationBar>
  <SelectedTheme>Default</SelectedTheme>
  <TrackingId></TrackingId>
</document>
XML;
        return simplexml_load_string($XML);
    }
}

function AddPageToNavigation_bootstrap($page, $currentpage, $pagesSorted, $level) {
    // Make sure there's both a menu and title attribute
    if ($page['menu'] == '') { $page['menu'] = $page['title']; }
    if ($page['title'] == '') { $page['title'] = $page['menu']; }

    // Check if the page has children
    $Children = getChildren($page['url']);
    if (count($Children) == 0) {
        // Just a regular link, no children
        $link = '<a href="' . find_url($page['url'], $page['parent']) . '" title="' . encode_quotes(cl($page['title'])) . '" target="_self">' . strip_decode($page['menu']) . '</a>';
        $submenu = '';
    } else {
        // We have children, create a submenu
        $caret = ($level == 1) ? '<b class="caret"></b>' : '';
        $link = '<a href="#" title="' . encode_quotes(cl($page['title'])) . '" class="dropdown-toggle" data-toggle="dropdown">' . strip_decode($page['menu']) . $caret . '</a>';

        $submenu = '<ul class="dropdown-menu sub-menu dropdown-menu-right">';

        foreach ($pagesSorted as $Child) {
            if ((in_array($Child['url'], $Children)) && ($Child['menuStatus'] == 'Y') && (($Child['private'] != 'Y') || ((isset($USR) && $USR == get_cookie('GS_ADMIN_USERNAME'))))) {
              $submenu .= AddPageToNavigation_bootstrap($Child, $currentpage, $pagesSorted, $level + 1);
            }
        }

        $submenu .= '</ul>';
    }
                 
    // Check if we're handling the page the user is on (or if the submenu contained the page the user is on)
    if (($currentpage == $page['url']) || (stripos($submenu, "current active") !== false)) {
        $li_classes = "current active " . $page['parent'] . " " . $page['url'];
    } else {
        $li_classes = trim($page['parent'] . " " . $page['url']);
    }
    if (count($Children) > 0) { 
        if ($level == 1) {
            $li_classes .= " dropdown"; 
        } else {
            $li_classes .= " dropdown-submenu";
        }
    }
                 
    return '<li class="' . $li_classes . '">' . $link . $submenu . '</li>' . "\n";
 
}

function get_navigation_bootstrap($currentpage) {
    global $pagesArray, $USR;

    $menu = '';

    $pagesSorted = subval_sort($pagesArray, 'menuOrder');
    if (count($pagesSorted) != 0) {
        foreach ($pagesSorted as $page) {
            if ((!$page['parent']) && ($page['menuStatus'] == 'Y') && (($page['private'] != 'Y') || ((isset($USR) && $USR == get_cookie('GS_ADMIN_USERNAME'))))) {
                // Append to the menu string
                $menu .= AddPageToNavigation_bootstrap($page, $currentpage, $pagesSorted, 1);
            }
        }
    }

    echo exec_filter('menuitems',$menu);
}


function SidebarToNavigation_bootstrap($page, $currentpage, $pagesSorted, $level,$i) {
    // Make sure there's both a menu and title attribute
    if ($page['menu'] == '') { $page['menu'] = $page['title']; }
    if ($page['title'] == '') { $page['title'] = $page['menu']; }

    // Check if the page has children
    $Children = getChildren($page['url']);
    if (count($Children) == 0) {
        // Just a regular link, no children
        $link = '<a href="' . find_url($page['url'], $page['parent']) . '" title="' . encode_quotes(cl($page['title'])) . '" class="list-group-item">' . strip_decode($page['menu']) . '</a>';
        $submenu = '';
    } else {
        // We have children, create a submenu
        $caret = ($level == 1) ? '<b class="caret"></b>' : '';
        $link = '<a href="#submenu'.$i.'" title="' . encode_quotes(cl($page['title'])) . '" data-toggle="collapse" class="list-group-item" >' . strip_decode($page['menu']) . $caret . '</a>';

        $submenu = '<div class="collapse list-group-submenu" id="submenu'.$i.'">';

        foreach ($pagesSorted as $Child) {
            if ((in_array($Child['url'], $Children)) && ($Child['menuStatus'] == 'Y') && (($Child['private'] != 'Y') || ((isset($USR) && $USR == get_cookie('GS_ADMIN_USERNAME'))))) {
              $submenu .= SidebarToNavigation_bootstrap($Child, $currentpage, $pagesSorted, $level + 1,$i);
            }
        }

        $submenu .= '</div>';
    }
                 
    // Check if we're handling the page the user is on (or if the submenu contained the page the user is on)
    if (($currentpage == $page['url']) || (stripos($submenu, "current active") !== false)) {
        $li_classes = "current active " . $page['parent'] . " " . $page['url'];
    } else {
        $li_classes = trim($page['parent'] . " " . $page['url']);
    }
    if (count($Children) > 0) { 
        if ($level == 1) {
            $li_classes .= " dropdown"; 
        } else {
            $li_classes .= " dropdown-submenu";
        }
    }
                 
    //return '<li class="' . $li_classes . '">' . $link . $submenu . '</li>' . "\n";
     return  $link . $submenu . "\n";
}
function get_bootstrap($currentpage) {
    if(empty($currentpage)){
       $currentpage ='';
   }
    global $pagesArray, $USR;

    $menu = '';

    $pagesSorted = subval_sort($pagesArray, 'menuOrder');
	$i=0;
    if (count($pagesSorted) != 0) {
        foreach ($pagesSorted as $page) {
            if ((!$page['parent']) && ($page['menuStatus'] == 'Y') && (($page['private'] != 'Y') || ((isset($USR) && $USR == get_cookie('GS_ADMIN_USERNAME'))))) {
                // Append to the menu string
                $menu .= SidebarToNavigation_bootstrap($page, $currentpage, $pagesSorted, 1,$i);
            }
            $i++;
        }
    }

    echo exec_filter('menuitems',$menu);
}



function FooterToNavigation_bootstrap($page, $currentpage, $pagesSorted, $level,$i) {
    if(empty($currentpage)){
       $currentpage ='';
   }
   $submenu='';
    // Make sure there's both a menu and title attribute
    if ($page['menu'] == '') { $page['menu'] = $page['title']; }
    if ($page['title'] == '') { $page['title'] = $page['menu']; }

    // Check if the page has children
    $Children = getChildren($page['url']);
    if (count($Children) == 0) {
        // Just a regular link, no children
        $link = '<div class=""><a href="' . find_url($page['url'], $page['parent']) . '" title="' . encode_quotes(cl($page['title'])) . '" class="footer-link">' . strip_decode($page['menu']) . '</a></div>';
        $submenu = '';
    } else {
        // We have children, create a submenu
        $caret = ($level == 1) ? '' : '';
        $link = '<div class=""><a href="' . find_url($page['url'], $page['parent']) . '" title="' . encode_quotes(cl($page['title'])) . '" class="footer-link" >' . strip_decode($page['menu']) . $caret . '</a></div>';

        //$submenu = '<div class="list-group-submenu" id="submenu'.$i.'">';

        foreach ($pagesSorted as $Child) {/*
            if ((in_array($Child['url'], $Children)) && ($Child['menuStatus'] == 'Y') && (($Child['private'] != 'Y') || ((isset($USR) && $USR == get_cookie('GS_ADMIN_USERNAME'))))) {
              $submenu .= FooterToNavigation_bootstrap($Child, $currentpage, $pagesSorted, $level + 1,$i);
            }
        */}

       // $submenu .= '</div>';
    }
                 
    // Check if we're handling the page the user is on (or if the submenu contained the page the user is on)
    if (($currentpage == $page['url']) || (stripos($submenu, "current active") !== false)) {
        $li_classes = "current active " . $page['parent'] . " " . $page['url'];
    } else {
        $li_classes = trim($page['parent'] . " " . $page['url']);
    }
    if (count($Children) > 0) { 
        if ($level == 1) {
            $li_classes .= " dropdown"; 
        } else {
            $li_classes .= " dropdown-submenu";
        }
    }
                 
    //return '<li class="' . $li_classes . '">' . $link . $submenu . '</li>' . "\n";
     return  $link . $submenu . "\n";
}
function get_allPages($currentpage) {
   if(empty($currentpage)){
       $currentpage ='';
   }
    global $pagesArray, $USR;

    $menu = '';

    $pagesSorted = subval_sort($pagesArray, 'menuOrder');
	$i=0;
    if (count($pagesSorted) != 0) {
        foreach ($pagesSorted as $page) {
            if ((!$page['parent']) && ($page['menuStatus'] == 'Y') && (($page['private'] != 'Y') || ((isset($USR) && $USR == get_cookie('GS_ADMIN_USERNAME'))))) {
                // Append to the menu string
                $menu .= FooterToNavigation_bootstrap($page, $currentpage, $pagesSorted, 1,$i);
            }
            $i++;
        }
    }

    echo exec_filter('menuitems',$menu);
	
	return $pagesArray;
}

function getSubMenu($page){
    $children=getChildren($page);
    foreach ($children as $subpage){
        $title=returnPageField($subpage,'menu');
        $url=returnPageField($subpage,'slug');
       //echo '<li><a href="index.php?id='.$url.'">'.$title.'</a></li>';
        // or use below if you have fancy urls on
         echo '<li><a href="/'.$url.'">'.$title.'</a></li>';
    }    
	
}
?>
